/*
 * $Id: vector.c,v 1.1.1.1 2002/05/04 09:19:09 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */

/**
 * Vector functions.
 *
 * @version $Revision: 1.1.1.1 $
 */
#include <math.h>

#include "putipati.h"
#include "vector.h"

Vector vctGetElement(Vector *v1, Vector *v2) {
  static Vector ans;
  long ll = v2->x*v2->x + v2->y*v2->y;
  if ( ll != 0 ) {
    float mag = v1->x*v2->x + v1->y*v2->y;
    ans.x = mag*v2->x/ll;
    ans.y = mag*v2->y/ll;
  } else {
    ans.x = ans.y = 0; 
  }
  return ans;
}

void vctAdd(Vector *v1, Vector *v2) {
  v1->x += v2->x;
  v1->y += v2->y;
}

void vctSub(Vector *v1, Vector *v2) {
  v1->x -= v2->x;
  v1->y -= v2->y;
}

void vctMul(Vector *v1, long a) {	
  v1->x = (v1->x*a)>>8;
  v1->y = (v1->y*a)>>8;
}

long vctSize(Vector *v) {
  long ax = abs(v->x), ay = abs(v->y);
  if ( ax > ay ) {
    return ax + (ay>>1);
  } else {
    return ay + (ax>>1);
  }
}
